Redmine - Defect #33829

Fix Atom feed for issues to correctly use the updated time for "updated” element instead of the

created time
2020-08-08 09:38 - Tatsuya Saito

Status: Reopened Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Feeds Estimated time: 0.00 hour
Target version: Candidate for next major release

Resolution: Fixed Affected version: 411
Description

There are updated tags in the Atom of issues list.
However, the created on is exported.

| have attached a patch to fix this.

Associated revisions

Revision 22764 - 2024-03-04 15:25 - Go MAEDA

Fix Atom feed for issues to correctly use the updated time for "updated” element instead of the created time (#33829).

Patch by Go MAEDA.

Revision 22770 - 2024-03-06 15:09 - Go MAEDA
Revert r22764 (#33829).

It breaks activities_controller_test.rb.

History

#1 - 2020-08-08 09:40 - Tatsuya Saito

This issue is reported in following Japanese forum.
https://groups.google.com/forum/#topic/redmine-users-ja/wb78I8uVJEY

#2 - 2020-08-08 15:05 - Tatsuya Saito

I'm sorry, patch.diff breaks Redmine rake test.
It breaks activity view items.
Please reject the patch.

#3 - 2020-08-08 17:28 - Tatsuya Saito
- File patch_trunk_r19958_pt1.diff added
- File patch_trunk_r19958_pt2.diff added

| think this problem only affects the atom of issues list.

There are updated tags created by issue.event_datetime.
But issue.event_datetime is created_on.

| think you need to use updated_on for the atom of issue list.

| re-create the patches for this issue.

In the first pattern, issue_controller overwrites issue.event_datetime between atom exports.
The second pattern, application_controller.rb and common/feed.atom.builder, adds the code for the problem list atom.

Both work, but | don't think it's clean code.

I'll attach both patches in the hope that it will help you think about better code.

#4 - 2020-09-06 07:00 - Go MAEDA

- Category changed from Issues list to Feeds

#5 - 2021-02-28 06:44 - Go MAEDA
- Target version set to Candidate for next major release

#6 - 2024-02-03 08:31 - Go MAEDA
- File 33829-v3.patch added

We can fix this issue by simply adding one line.

diff --git a/app/models/issue.rb b/app/models/issue.rb
index 670921eb0..408ab485b 100644

-—— a/app/models/issue.rb

+++ b/app/models/issue.rb

@@ -48,6 +48,7 Q@ class Issue < ApplicationRecord

:scope => lambda {|options| options[:open_issues] ? self.open : self.all}
acts_as_event :title => Proc.new {|o| "#{o.tracker.name} ##{o.id} (#{o.status}): #{o.subject}"},
+ :datetime => Proc.new {|o| o.updated_on},
:url => Proc.new {|o| {:controller => 'issues', :action => 'show', :id => o.id}},
:type => Proc.new {|o| 'issue' + (o.closed? ? '-closed' : '')}

#7 - 2024-02-03 09:45 - Go MAEDA

- Subject changed from Tags "updated” in issues atom are "created on" to Atom feed for issues incorrectly uses created time instead of updated time
for "updated" elements

- Target version changed from Candidate for next major release to 6.0.0

Setting the target version to 6.0.0.

#8 - 2024-03-04 15:26 - Go MAEDA

- Subject changed from Atom feed for issues incorrectly uses created time instead of updated time for "updated” elements to Fix Atom feed for issues
to correctly use the updated time for "updated” element instead of the created time

- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r22764.

#9 - 2024-03-04 21:24 - Marius BALTEANU

3 tests fail after this change:

Failure:
ActivitiesControllerTest#test_previous_project_index [test/functional/activities_controller_test.rb:91]:
Expected: /1/
Actual: "Project".
Expected 0 to be >= 1.

bin/rails test test/functional/activities_controller_test.rb:80
F
Failure:
ActivitiesControllerTest#test_global_index [test/functional/activities_controller_test.rb:103]:
Expected: /28/
Actual: "Project".
Expected 0 to be >= 1.
bin/rails test test/functional/activities_controller_test.rb:95
oI5
Failure:
ActivitiesControllerTest#test_user_index [test/functional/activities_controller_test.rb:123]:
Expected: /1/
Actual: "Project".
Expected 0 to be >= 1.

bin/rails test test/functional/activities_controller_test.rb:107

You can see the status here https://www.redmine.org/builds/logs/build_trunk_mysql_ruby-3.2_1017.html
On my local environment, reverting this change fixes all tests.

#10 - 2024-03-04 21:24 - Marius BALTEANU

- Status changed from Closed to Reopened

#11 - 2024-03-06 15:10 - Go MAEDA

- Target version changed from 6.0.0 to Candidate for next major release

Marius BALTEANU wrote in #note-9:
3 tests fail after this change:

(-]

You can see the status here https://www.redmine.org/builds/logs/build_trunk_mysql ruby-3.2_1017.html

On my local environment, reverting this change fixes all tests.

Thank you, | have reverted the change in r22770.

Files

patch.diff 759 Bytes 2020-08-08 Tatsuya Saito
patch_trunk_r19958 pt1.diff 2.64 KB 2020-08-08 Tatsuya Saito
patch_trunk_r19958_pt2.diff 924 Bytes 2020-08-08 Tatsuya Saito
33829-v3.patch 1.59 KB 2024-02-03 Go MAEDA
